//******************************************************************************
//*                       Raster Technolodgy SDK v2.xx                         *
//*               <    UserCap.dll >              *
//*              Copyright (C)  " ", 2003-2006               *
//*                       :                             *
//*          phone: (495) 789-93-67,  e-mail: rastr_support@mail.ru            *
//******************************************************************************


unit test;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, Buttons, UsCapDef;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Paint: TPaintBox;
    TrBar: TTrackBar;
    StaticText4: TStaticText;
    Bevel1: TBevel;
    StaticText6: TStaticText;
    Paint1: TPaintBox;
    Bevel2: TBevel;
    Label3: TLabel;
    GroupBox1: TGroupBox;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    Button6: TButton;
    Button5: TButton;
    Button4: TButton;
    Button3: TButton;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    BitBtn1: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn10: TBitBtn;
    Button8: TButton;
    Button12: TButton;
    StaticText5: TStaticText;
    Button7: TButton;
    Button11: TButton;
    StayOnTop: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure TrBarChange(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure BitBtnShowClick(Sender: TObject);
    procedure BitBtnHideClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1:              TForm1;
  Hd:                 THandle;
  Count:              integer;
  Win:                integer;
  Pixels:             array of byte;
  Len:                integer;
  Bmp:                TBitmap;


implementation


{$R *.dfm}

Function VersionToStr(version: longword):string;
   Type
     LW = array[0..3] of byte;
   Var
     p: ^LW;
   Begin
     p:=@version;
     result:=IntToStr(p^[3])+'.'+IntToStr(p^[2])+'.'+IntToStr(p^[1])+'.'+IntToStr(p^[0]);
   End;

Procedure OnCapture1(buf: pointer; width, height, bits: integer;
                                         capStatus, recStatus: integer; var canRec: boolean);stdcall;
   Var
     p:                  pointer;
     h,s:                integer;
   Begin
     ZeroMemory(buf, width*16);
   End;

Procedure OnCapture2(buf: pointer; width, height, bits: integer;
                                         capStatus, recStatus: integer; var canRec: boolean);stdcall;
   Var
     s:                integer;
   Begin
     s:=width*height*((bits+7) div 8);
     If s>Len then
       Begin
         SetLength(Pixels, s);
         Len:=s;
       end;
     UserCap_CopyFrame(buf, @Pixels[0], width, height, bits, TRUE, TRUE);
     Bmp.Handle:=UserCap_FrameToHBITMAP(@Pixels[0],width, height, 8, FALSE);
     Form1.Paint.Canvas.Draw(0,0, Bmp);

     Form1.StaticText1.Caption:=IntToStr(UserCap_GetCapacity);
     Form1.StaticText2.Caption:=IntToStr(UserCap_GetCountFrames);
     Form1.StaticText3.Caption:=IntToStr(RecStatus);
     Form1.StaticText6.Caption:=IntToStr(CapStatus);
   End;


Procedure OnGetFrame(buf: pointer; width, height, bits: integer;
                                         capStatus, recStatus: integer; var canRec: boolean);stdcall;
   Var
     h:               integer;
   Begin
     h:=Form1.Paint1.Canvas.Handle;
     BitBlt(h,0,0,width,height, UserCap_FrameToHDC(buf,width, height, bits, TRUE),0,0, SRCCOPY);
     Form1.StaticText1.Caption:=IntToStr(UserCap_GetCapacity);
     Form1.StaticText2.Caption:=IntToStr(UserCap_GetCountFrames);
     Form1.StaticText3.Caption:=IntToStr(RecStatus);
     Form1.StaticText6.Caption:=IntToStr(CapStatus);
   End;


procedure TForm1.FormCreate(Sender: TObject);
begin
  Hd:=LoadLibrary('UserCap.dll');
  If ConnectToLibraryInterface(Hd)=FALSE then
    Begin
      Hd:=0;
      Application.MessageBox('   !', '', 0);
      Exit;
    end;
  UserCap_OpenDevice(1);
  Len:=0;
  Caption:=Caption+' - '+VersionToStr(UserCap_LibraryVersion);
  Bmp:=TBitmap.Create;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  If Hd=0 then Close;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  SetLength(Pixels,0);
  If (hd<>0) then
    Begin
      UserCap_CloseDevice;
      FreeLibrary(hd);
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  UserCap_StartCapture(OnCapture1, OnCapture2);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  UserCap_StopCapture;
  Button6Click(nil);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  UserCap_StartRec;
  Form1.StaticText1.Caption:=IntToStr(UserCap_GetCapacity);
  Form1.StaticText2.Caption:=IntToStr(UserCap_GetCountFrames);
  Form1.StaticText3.Caption:=IntToStr(UserCap_GetRecStatus);
  TrBar.Enabled:=FALSE;
  TrBar.Min:=0;
  TrBar.Max:=0;
  TrBar.Position:=0;
  StaticText4.Caption:='0';
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  UserCap_PauseRec;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  UserCap_ContinueRec;
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  c: integer;
begin
  UserCap_StopRec;
  Application.ProcessMessages;
  c:=UserCap_GetCountFrames;
  If c=0 then Exit;
  TrBar.Min:=1;
  TrBar.Position:=1;
  TrBar.Max:=c;
  TrBarChange(nil);
  TrBar.Enabled:=TRUE;

end;

procedure TForm1.TrBarChange(Sender: TObject);
begin
  StaticText4.Caption:=IntToStr(TrBar.Position);
  If TrBar.Position<>0 then UserCap_GetFrame(TrBar.Position, OnGetFrame);
end;

//***************************   ********************************

Procedure OnHideWin(param, status: integer);stdcall;
   Var
     but:  TBitBtn;
   Begin
     Case param of
     0: but:=Form1.BitBtn1;
     1: but:=Form1.BitBtn2;
     2: but:=Form1.BitBtn3;
     3: but:=Form1.BitBtn4;
     4: but:=Form1.BitBtn5;
     else Exit;
     end;
     but.Font.Color:=clBlack;
   End;

procedure TForm1.BitBtnShowClick(Sender: TObject);
var
  but:  TBitBtn;
begin
  but:=TBitBtn(Sender);
  but.Font.Color:=clRed;
  UserCap_ShowWindow(but.Tag, Ord(StayOnTop.Checked), OnHideWin);
  win:=but.Tag;
  StaticText5.Caption:=IntToStr(win);
end;

procedure TForm1.BitBtnHideClick(Sender: TObject);
begin
  UserCap_HideWindow(TBitBtn(Sender).Tag);
end;

procedure TForm1.Button8Click(Sender: TObject);
var
  left,top:  integer;
begin
  UserCap_GetWindowPos(win,left,top);
  UserCap_SetWindowPos(win,left-4, top);
end;

procedure TForm1.Button7Click(Sender: TObject);
var
  left,top:  integer;
begin
  UserCap_GetWindowPos(win,left,top);
  UserCap_SetWindowPos(win,left+4, top);
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  left,top:  integer;
begin
  UserCap_GetWindowPos(win,left,top);
  UserCap_SetWindowPos(win,left,top-4);
end;

procedure TForm1.Button12Click(Sender: TObject);
var
  left,top:  integer;
begin
  UserCap_GetWindowPos(win,left, top);
  UserCap_SetWindowPos(win,left, top+4);
end;



end.
