//******************************************************************************
//*                       Raster Technolodgy SDK v2.xx                         *
//*             <     UserCap.dll >              *
//*              Copyright (C)  " ", 2003-2006               *
//*                       :                             *
//*          phone: (495) 789-93-67,  e-mail: rastr_support@mail.ru            *
//******************************************************************************


unit UsCapDef;

INTERFACE

Uses Windows;

TYPE
  TNotifyProc = Procedure(param,status: integer);stdcall;
  TOnCapture = Procedure(framePtr: pointer; width, height, bits: integer;
                                    capStatus, recStatus: integer; var canRec:boolean);stdcall;

CONST
  INTERFACE_VERSION = $01000000;

VAR
  UserCap_LibraryVersion:     Function:longword;stdcall;
  UserCap_InterfaceVersion:   Function:longword;stdcall;
  UserCap_OpenDevice:         Function(mode: integer):integer;stdcall;
  UserCap_CloseDevice:        Procedure;stdcall;
  UserCap_ShowWindow:         Function(win, flags: integer; OnHide: TNotifyProc):integer;stdcall;
  UserCap_HideWindow:         Procedure(win: integer);stdcall;
  UserCap_SetWindowPos:       Function(win: integer; left,top: integer):integer;stdcall;
  UserCap_GetWindowPos:       Function(win: integer; var left,top: integer):integer;stdcall;
  UserCap_StartCapture:       Function(OnCapture1, OnCapture2: TOnCapture):integer;stdcall;
  UserCap_StopCapture:        Procedure;stdcall;
  UserCap_StartRec:           Function:integer;stdcall;
  UserCap_PauseRec:           Function:integer;stdcall;
  UserCap_ContinueRec:        Function:integer;stdcall;
  UserCap_StopRec:            Function:integer;stdcall;
  UserCap_GetFrame:           Function(frame:integer; OnGetFrame: TOnCapture):integer;stdcall;
  UserCap_GetRecStatus:       Function:integer;stdcall;
  UserCap_GetCountFrames:     Function:integer;stdcall;
  UserCap_GetCapacity:        Function:integer;stdcall;
  UserCap_FrameToHDC:         Function(frameBuf:pointer; width, height, bits:integer; inverseOrderLines: boolean):HDC;stdcall;
  UserCap_FrameToHBitmap:     Function(frameBuf:pointer; width, height, bits:integer; inverseOrderLines: boolean):integer;stdcall;
  UserCap_CopyFrame:          Procedure(frameBuf: pointer; destBuf: pointer; width, height, bits: integer;
                                                  copy16to8, inverseOrderLines: boolean);stdcall;

Function CheckLibrary(Hd: longword):integer;
Function ConnectToLibraryInterface(Hd: longword):boolean;


IMPLEMENTATION

Procedure InitVar(Hd: longword; var result: boolean; var addr; name: PChar);
   Var
     p: ^longword;
   Begin
     p:=@addr;
     p^:=Longword(GetProcAddress(Hd, name));
     result:=result and (p^<>0);
   End;

Function CheckLibrary;
   Var
     f:  boolean;
   Begin
     f:=TRUE;
     result:=2;
     InitVar(Hd, f, UserCap_InterfaceVersion, 'UserCap_InterfaceVersion');
     If f=FALSE then Exit;
     result:=1;
     If UserCap_InterfaceVersion<INTERFACE_VERSION then Exit;
     result:=0;
   End;

Function ConnectToLibraryInterface;
   Begin
     result:=FALSE;
     If CheckLibrary(Hd)<>0 then Exit;
     result:=TRUE;
     InitVar(Hd, result, UserCap_InterfaceVersion, 'UserCap_InterfaceVersion');
     InitVar(Hd, result, UserCap_LibraryVersion,   'UserCap_LibraryVersion');

     result:=TRUE;
     InitVar(Hd, result, UserCap_OpenDevice,       'UserCap_OpenDevice');
     InitVar(Hd, result, UserCap_CloseDevice,      'UserCap_CloseDevice');

     InitVar(Hd, result, UserCap_ShowWindow,       'UserCap_ShowWindow');
     InitVar(Hd, result, UserCap_HideWindow,       'UserCap_HideWindow');
     InitVar(Hd, result, UserCap_GetWindowPos,     'UserCap_GetWindowPos');
     InitVar(Hd, result, UserCap_SetWindowPos,     'UserCap_SetWindowPos');

     InitVar(Hd, result, UserCap_StartCapture,     'UserCap_StartCapture');
     InitVar(Hd, result, UserCap_StopCapture,      'UserCap_StopCapture');
     InitVar(Hd, result, UserCap_StartRec,         'UserCap_StartRec');
     InitVar(Hd, result, UserCap_PauseRec,         'UserCap_PauseRec');
     InitVar(Hd, result, UserCap_ContinueRec,      'UserCap_ContinueRec');
     InitVar(Hd, result, UserCap_StopRec,          'UserCap_StopRec');
     InitVar(Hd, result, UserCap_GetRecStatus,     'UserCap_GetRecStatus');
     InitVar(Hd, result, UserCap_GetCapacity,      'UserCap_GetCapacity');
     InitVar(Hd, result, UserCap_GetCountFrames,   'UserCap_GetCountFrames');
     InitVar(Hd, result, UserCap_GetFrame,         'UserCap_GetFrame');

     InitVar(Hd, result, UserCap_CopyFrame,        'UserCap_CopyFrame');
     InitVar(Hd, result, UserCap_FrameToHDC,       'UserCap_FrameToHDC');
     InitVar(Hd, result, UserCap_FrameToHBITMAP,   'UserCap_FrameToHBITMAP');

   End;

END.
